/*#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,fma,tune=native")
*/
#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
using namespace std;
const ld eps = 1e-9;

struct Vector {
    ld x, y;

    void in() {
        cin >> x >> y;
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    ld operator%(Vector a) {
        return x * a.y - y * a.x;
    }

    ld operator*(Vector a) {
        return x * a.x + y * a.y;
    }

    Vector operator*(ld k) {
        return {k * x, k * y};
    }

    ld len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrtl(len2());
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;
    Vector p0 = {(ld) x0, (ld) y0}, p1 = {(ld) x1, (ld) y1};
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].F;
        a[i].S = i;
        sum += a[i].F;
    }
    if (sum * sum < (x0 - x1) * (x0 - x1) + (y1 - y0) * (y1 - y0)) {
        cout << "Impossible";
        return 0;
    }
    sort(a.rbegin(), a.rend());
    vector<Vector> st(n);
    Vector now = p0;
    for (int i = 0; i < n; ++i) {
        if (sum * sum + eps < (p1 - now).len2()) {
            cout << "Impossible";
            return 0;
        }
        if (a.back().F > sum - a.back().F + (now - p1).len() + eps) {
            cout << "Impossible";
            return 0;
        }
        sum -= a[i].F;
        if (sum >= (p1 - now).len() + a[i].F + eps) {
            Vector dx = (now - p1) * a[i].F * (1.0 / (now - p1).len());
            st[i] = dx;
            now = now + dx;
        } else {
            ld a1 = a[i].F, b1 = sum, c1 = (now - p1).len();
            if ((p1 - now).len() > b1) {
                ld o = acos((b1 * b1 - a1 * a1 - c1 * c1) / (-2 * a1 * c1));
                ld h = sin(o) * a1;
                ld c_1 = sqrtl(a1 * a1 - h * h);
                Vector pt = now + (p1 - now) * (1.0 / (p1 - now).len()) * c_1;
                Vector op = (p1 - now);
                op = {-op.y, op.x};
                op = op * (1.0 / op.len()) * h;
                pt = pt + op;
                Vector vec = pt - now;
                st[i] = vec;
                now = now + vec;
            } else {
                ld o = acos((a1 * a1 - b1 * b1 - c1 * c1) / (-2 * b1 * c1));
                ld h = sin(o) * b1;
                ld c_1 = sqrtl(b1 * b1 - h * h) - c1;
                Vector pt = now + (now - p1) * (1.0 / (p1 - now).len()) * c_1;
                Vector op = (p1 - now);
                op = {-op.y, op.x};
                op = op * (1.0 / op.len()) * h;
                pt = pt + op;
                Vector vec = pt - now;
                st[i] = vec;
                now = now + vec;
            }
        }
    }
    vector<Vector> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[a[i].S] = st[i];
    }
    cout << fixed << setprecision(15);
    cout << "Possible\n";
    for (int i = 0; i < n; ++i) {
        p0 = p0 + ans[i];
        cout << p0.x << " " << p0.y << '\n';
    }
    return 0;
}
