#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct P
{
    P(){x = 0;y = 0;};
    P(ll _x,ll _y){x = _x;y = _y;};
    P operator +(P b)
    {
        return P(x+b.x,y+b.y);
    }
    P operator -(P b)
    {
        return P(x-b.x,y-b.y);
    }
    P operator *(ll k)
    {
        return P(x*k,y*k);
    }
    ll x, y;
};
constexpr ld eps = 1e-9;

struct Pd
{
    Pd(){x = 0;y = 0;};
    Pd(ld _x,ld _y){x = _x;y = _y;};
    Pd(P a){x = a.x;y = a.y;};
    Pd operator +(Pd b)
    {
        return Pd(x+b.x,y+b.y);
    }
    Pd operator -(Pd b)
    {
        return Pd(x-b.x,y-b.y);
    }
    Pd operator *(ld k)
    {
        return Pd(x*k,y*k);
    }
    Pd operator /(ld k)
    {
        return Pd(x/k,y/k);
    }
    ld len() const {
        return sqrtl(x * x + y * y);
    }
    ld len2() {
        return x * x + y * y;
    }
    ld x, y;
    Pd unit()  {
//        cout << len() << endl;
        if (len() < eps) {
            return {1, 0};
        }
        return (*this) / len();
    }
};

ld dist2(Pd a, Pd b) {
    return (a - b).len2();
}

ld distd(Pd a,Pd b)
{
    return sqrtl((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}

vector<Pd> inter(Pd c1,ll r1,Pd c2,ll r2)
{
    if(abs(c1.x-c2.x) < eps && abs(c1.y-c2.y) < eps)
    {
        if(r1 == r2)
        {
            return {Pd(c1.x + r1,c1.y)};
        }
        else
        {
            return {};
        }
    }
    if((r1 + r2)*(r1+r2) < dist2(c1,c2) - eps)
    {
        return {};
    }
    else
    {
        ld d = distd(c1,c2);
        if(r1 < r2)
        {
            swap(r1,r2);
            swap(c1,c2);
        }
        if((r1-r2)*(r1-r2) > dist2(c1,c2) + eps)
        {
            return {};
        }
        else if(abs((r1 + r2)*(r1+r2) - dist2(c1,c2)) < eps)
        {
            Pd ans(c1);
            Pd r(c2-c1);
            r = r * (ld(r1)/(r1+r2));
            ans  = ans + r;
            return {ans};
        }
        else if(abs((r1-r2)*(r1-r2) - dist2(c1,c2)) < eps)
        {
            Pd ans(c1);
            Pd r(c2-c1);
            r = r * (ld(r1)/d);
            ans = ans + r;
            return {ans};
        }
        else
        {
            ld x = (r1*r1+d*d-r2*r2)/(2*d);
            ld y = sqrtl(abs(r1*r1-x*x));
            Pd ans(c1);
            Pd r(c2-c1);
            r = r * (x / d);
            ans = ans + r;
            Pd r2 (c2-c1);
            Pd perp(-r2.y,r2.x);
            perp = perp * (y / d);
//            cout << x << ' ' << y << "\n";
            return {ans+perp,ans-perp};
        }
    }
}

bool incircle(Pd a,Pd c,ll r)
{

    return abs(distd(a,c) - r) < 1e-9;
}

ll dist(P x, P y) {
    return (x.x - y.x) * (x.x - y.x) + (x.y - y.y) * (x.y - y.y);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(20);
    ll x0,y0,x1,y1;
    cin >> x0 >> y0 >> x1 >> y1;
    P I = P(x0, y0);
    P O = P(x1, y1);
    Pd Id = Pd(x0, y0);
    Pd Od = Pd(x1, y1);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a.begin(), a.end(), greater<>());
    vector<Pd> res(n);
    int suma = 0;
    for (auto [x, y] : a) {
        suma += x;
    }
    if (dist(I, O) > 1LL * suma * suma) {
        cout << "Impossible\n";
        return 0;
    }
    int maxd = a[0].first;
    ld dst = distd(Id, Od);
    if (maxd * 2 - suma >= 0 && 1LL * (maxd * 2 - suma) * (maxd * 2 - suma) > dist(I, O)) {
        cout << "Impossible\n";
        return 0;
    }
    if (suma <= maxd * 2 || dist(I, O) > 1LL * (suma - maxd * 2) * (suma - maxd * 2)) {
        auto f = inter(I, maxd, O, suma - maxd);
        assert(!f.empty());
        auto mid = f[0];
        auto pd = (mid - I);
        res[a[0].second] = pd;
        pd = (Od - mid);
        pd = pd.unit();
        for (int i = 1; i < n; ++i) {
            res[a[i].second] = pd * a[i].first;
        }
        cerr << "where are in the first if" << endl;
    } else {
        auto pd = (Id - Od);
        pd = pd.unit();
//        cout << pd.x << " " << pd.y << endl;
        res[a[0].second] = pd * a[0].first;
        Pd newI = Id + res[a[0].second];
        int suml = 0, sumr = suma - maxd;
        bool any = false;
//        cout << newI.x << " " << newI.y << " to " << Od.x << " " << Od.y << endl;
        for (int i = 0; i < n; ++i) {
            if (i > 0) {
                suml += a[i].first;
                sumr -= a[i].first;
            }
            auto f = inter(newI, suml, Od, sumr);
            any |= !f.empty();
            if (!f.empty()) {
                auto mid = f[0];
                pd = (mid - newI).unit();
                for (int j = 1; j <= i; ++j) {
                    res[a[j].second] = pd * a[j].first;
                }
                pd = (Od - mid).unit();
                for (int j = i + 1; j < n; ++j) {
                    res[a[j].second] = pd * a[j].first;
                }
                break;
            }
        }
        assert(any);
    }
    cout << "Possible\n";
    Pd init = Id;
    for (int i = 0; i < n; ++i) {
        init = init + res[i];
        cout << init.x << " " << init.y << "\n";
    }
    assert((init - Od).len() < eps);
}