#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = long double;

constexpr ll infLL = 3e18;

struct Line {
    ll k = 0, b = infLL;
    ll eval(ll x) {
        return k * x + b;
    }
    db inter(Line o) {
        return (o.b - b) / db(k - o.k);
    }
};

struct CHT {
    vector<Line> t;
    void add(Line o) {
        if (!t.empty() && t.back().k == o.k) {
            if (o.b > t.back().b) {
                return;
            }
            t.pop_back();
        }
        while (t.size() > 1 && o.inter(t.end()[-2]) <= t.back().inter(t.end()[-2])) {
            t.pop_back();
        }
        t.push_back(o);
    }
    ll eval(ll x) {
        int lo = 0, hi = t.size() - 1;
        while (lo < hi) {
            int mid = lo + hi >> 1;
            if (t[mid + 1].eval(x) <= t[mid].eval(x)) {
                lo = mid + 1;
            } else {
                hi = mid;
            }
        }
        return t[lo].eval(x);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(20);

    int n, m, c;
    cin >> n >> m >> c;
    vector<ll> x(n + 2), t(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> t[i];
        t[i] *= c;
    }
    x[n + 1] = m;

    n += 2;
    vector<ll> dp(n, infLL);
    dp[0] = 0;
    CHT cht;
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            dp[i] = x[i] * x[i] + t[i] + cht.eval(x[i]);
        }
        {
            Line o;
            o.k = -2 * x[i];
            o.b = dp[i] + x[i] * x[i];
            cht.add(o);
        }
    }
    cout << dp[n - 1] / db(c) << '\n';

    return 0;
}
