#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 998244353, P = 12411, N = 3e5 + 7;

int msum(int a, int b) {
    return a + b < MOD ? a + b : a + b - MOD;
}

void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

int powers[N];

void init_powers() {
    powers[0] = 1;
    for (int i = 1; i < N; ++i) {
        powers[i] = 1LL * powers[i - 1] * P % MOD;
    }
}

vector<int> getHashed(vector<int> a) {
    int m = a.size();
    vector<int> pref(m + 1);
    for (int i = 0; i < m; ++i) {
        pref[i + 1] = (1LL * pref[i] * P + a[i]) % MOD;
    }
    return pref;
}

constexpr int INF = 1e9 + 7;

struct S {
    array<int, 2> mn[2]{{INF, -1}, {INF, -1}};
    void update(array<int, 2> u) {
        if (u[0] < mn[0][0]) {
            swap(u, mn[0]);
        }
        if (u[1] == mn[0][1]) {
            return;
        }
        mn[1] = min(mn[1], u);
    }
    void upd(S o) {
        for (auto x : o.mn) {
            update(x);
        }
    }
};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<int> p(n), pos(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        pos[p[i]] = i;
    }

    vector<int> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }

    vector<int> prefP = getHashed(p);
    vector<int> prefA = getHashed(a);

    auto rangeHash = [&](int l, int r, vector<int> &pref) {
        assert(l >= 0 && l < r && r < pref.size());
        int res = (pref[r] - pref[l] * 1LL * powers[r - l]) % MOD;
        if (res < 0) {
            res += MOD;
        }
        return res;
    };

    vector<array<int, 2>> s(k);
    vector<int> beg(k), en(k);
    vector<S> dp(n + 1);
    dp[n].update({0, -1});
    vector<vector<pair<int, int>>> full(n);
    // check if answer is 1
    vector<int> nx(m + 1, m + 1);
    for (int i = m - 1; i >= 0; --i) {
        if (i + n <= m && rangeHash(0, n, prefP) == rangeHash(i, i + n, prefA)) {
            nx[i] = i;
        } else {
            nx[i] = nx[i + 1];
        }
    }
    array<int, 3> ans{INF, -1, -1};
    vector<vector<int>> possible(n);
    for (int i = 0; i < k; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        if (nx[l] + n <= r) {
            ans = {1, -1, i};
            break;
        }
        if (i == 2) {

        }
        int po = pos[a[l]];
        if (po + r - l <= n && rangeHash(l, r, prefA) == rangeHash(po, po + r - l, prefP)) {
//            cout << "full: " << i << " " << po << endl;
            beg[i] = r - l;
            full[po].push_back({r - l, i});
        }
        int t = min(r - l, n - po);
        if (po + t == n && rangeHash(l, l + t, prefA) == rangeHash(po, po + t, prefP)) {
//            cout << i << ": " << po << endl;
            dp[po].update(array<int, 2>{1, i});
        }
        po = pos[a[r - 1]];
        if (r - po - 1 >= 0 && rangeHash(r - po - 1, r, prefA) == rangeHash(0, po + 1, prefP)) {
            en[i] = po + 1;
//            cout << "possible: " << i << " " << po + 1 << endl;
            possible[po + 1].push_back(i);
        }
//        cout << beg[i] << " " << en[i] << endl;
    }
//    cout << ans[0] << endl;
//    cout << ans[1] << endl;
//    cout << ans[2] << endl;
    if (ans[0] != 1) {
        possible[0].push_back(-1);
        for (int i = n - 1; i >= 0; --i) {
            for (auto [t, j]: full[i]) {
                auto f = dp[i + t];
                f.mn[0][0] += 1;
                f.mn[1][0] += 1;
                dp[i].upd(f);
            }
            for (int id: possible[i]) {
                for (auto [x, y]: dp[i].mn) {
                    if (y != id) {
                        ans = min(ans, {x + (id != -1), i, id});
                    }
                }
            }
//            cout << dp[i].mn[0][0] << " " << dp[i].mn[0][1] << endl;
        }
    }
//    cout << ans[0] << endl;
//    cout << ans[1] << endl;
//    cout << ans[2] << endl;
    if (ans[0] > k) {
        cout << "-1\n";
        return;
    }
    cout << ans[0] << '\n';
    vector<int> res;
    if (ans[0] == 1 && ans[2] != -1) {
        res.push_back(ans[2]);
    } else {
        int cnt = ans[0], i = ans[1], id = ans[2];
        if (id != -1) {
            res.push_back(id);
            cnt -= 1;
        }
//        cout << id << endl;
        while (cnt > 0) {
//            cout << "cnt i: " << cnt << " " << i << endl;
            if (cnt == 1) {
                int found = -1;
                for (auto [u, v]: dp[i].mn) {
//                    cout << u << " " << v << endl;
                    if (v != -1 && v != id && u == cnt) {
                        found = v;
                    }
                }
                if (found != -1) {
                    assert(found != -1);
                    res.push_back(found);
                    break;
                }
            }
            int any = -1;
            int nx = -1;
            for (auto [x, j]: full[i]) {
                bool found = false;
                for (auto [u, v]: dp[i + x].mn) {
                    if (v != id && u + 1 == cnt) {
                        found = true;
                    }
                }
                if (found) {
                    any = j;
                    nx = i + x;
                    break;
                }
            }
            assert(any != -1);
            res.push_back(any);
            i = nx;
            cnt -= 1;
        }
    }
    for (int x : res) {
        cout << x + 1 << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    init_powers();

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
