#include <bits/stdc++.h>

#define int long long
using namespace std;
using ll = long long;
using ld = long double;

void fast_in_out() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
}

struct pt {
    ll x, y;

    pt() : x(0), y(0) {}

    pt(ll x, ll y) : x(x), y(y) {}

    pt(pt x, pt y) : x(y.x - x.x), y(y.y - x.y) {}

    pt(const pt &a) : x(a.x), y(a.y) {}

    void operator+=(const pt a) {
        x += a.x;
        y += a.y;
    }

    pt operator+(const pt a) {
        pt res = *this;
        res += a;
        return res;
    }

    void operator-=(const pt a) {
        x -= a.x;
        y -= a.y;
    }

    pt operator-(const pt a) {
        pt res = *this;
        res -= a;
        return res;
    }

    pt operator*(ld a) {
        return pt(x * a, y * a);
    }

    ld len() {
        return sqrt(x * x + y * y);
    }

    ll len2() {
        return x * x + y * y;
    }

    ll operator*(const pt a) {
        return x * a.x + y * a.y;
    }

    ll operator%(const pt a) {
        return x * a.y - y * a.x;
    }

    pt turn() {
        return {-y, x};
    }
};

signed main() {
    fast_in_out();
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    pt v12(x2 - x1, y2 - y1), v21(x1 - x2, y1 - y2);
    pt v13(x3 - x1, y3 - y1), v31(x1 - x3, y1 - y3);
    pt v23(x3 - x2, y3 - y2), v32(x2 - x3, y2 - y3);
    double a = double(double(abs(v12 % v13)) / v12.len()), b = double(double(abs(v23 % v21)) / v23.len()), c = double(
            double(abs(v12 % v13)) / v13.len());
    if (min({a, b, c}) == a) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    } else if (min({a, b, c}) == b) {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
    } else {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    }
    return 0;
}
