#include <bits/stdc++.h>
using namespace std;
double eval(int x, double b, double coeff){
    return x*coeff + b;
}
struct seg_tree{
    seg_tree* left_child = nullptr, *right_child = nullptr;
    int l, r;
    double val_on_l = INFINITY, val_on_r = INFINITY;
    bool one_line = true;
    double b = INFINITY;
    double coeff = 0;
    seg_tree(int l, int r) : l(l), r(r){}
    bool check_children(){
        return left_child != nullptr;
    }
    void get_pushed(double _b, double _coeff){
        one_line = true;
        b = _b;
        coeff = _coeff;
        val_on_l = eval(l, b, coeff);
        val_on_r = eval(r, b, coeff);
    }
    double get(int x){
        if (one_line)
            return eval(x, b, coeff);
        if (x < l || r < x)
            return INFINITY;
        return min(left_child->get(x), right_child->get(x));

    }
    void add_line(double _b, double _coeff){
        double left_ev = eval(l, _b, _coeff);
        double right_ev = eval(r, _b, _coeff);
        if (left_ev < val_on_l && right_ev < val_on_r && one_line){
            get_pushed(_b, _coeff);
            return;
        }
        else
        if (left_ev >= val_on_l && right_ev >= val_on_r && one_line){
            return;
        }
        if (!check_children()){
            int mid = (l+r)/2;
            left_child = new seg_tree(l, mid);
            right_child = new seg_tree(mid+1, r);
            left_child->get_pushed(_b, _coeff);
            right_child->get_pushed(_b, _coeff);
        }
        left_child->add_line(_b, _coeff);
        right_child->add_line(_b, _coeff);
        one_line = false;
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int64_t n, m, c;
    cin >> n >> m >> c;
    std::vector<int64_t> x(n+2), t(n+2);
    for (int i = 0; i < n; i++)
    {
        cin >> x[i+1] >> t[i+1];
    }
    
    std::vector<double> dp(n+2, INFINITY);
    dp[0] = 0;
    t[0] = 0;
    t[n+1] = 0;
    x[0] = 0;
    x[n+1] = m;
    seg_tree str(0, m);
    str.add_line(0, 0);
    for (int i = 1; i <= n+1; i++)
    {
        dp[i] = str.get(x[i]) + x[i]*(double)x[i]/(double)c;
        dp[i] += t[i];
        str.add_line(dp[i] + x[i]*(double)x[i]/(double)c, -2.0*x[i]/(double)c);
    }
    cout << fixed << setprecision(10) << dp.back();
}