#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define F first
#define ve vector
#define S second
#define int ll
#define debug(x) cout << "DEBUG " << (#x) << " = " << x << '\n';

ld pi = acos(-1);
const ld e = 1e-6;

template<class T>
istream &operator>>(istream &in, ve<T> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class T>
ostream &operator<<(ostream &out, ve<T> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct Vector {
    ld x, y;

    explicit Vector(ld x = 0, ld y = 0) : x(x), y(y) {

    }

    Vector operator+(Vector other) const {
        return Vector(x + other.x, y + other.y);
    }

    Vector operator-(Vector other) const {
        return Vector(x - other.x, y - other.y);
    }

    Vector operator*(ld k) const {
        return Vector(x * k, y * k);
    }

    ld length() const {
        return sqrtl(x * x + y * y);
    }

    ld length2() const {
        return x * x + y * y;
    }

    Vector normolized() const {
        ld len = length();
        return Vector(x / len, y / len);
    }
};

istream &operator>>(istream &in, Vector &a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, Vector a) {
    out << a.x << ' ' << a.y;
    return out;
}

struct Circle {
    Vector center;
    ld r;

    Circle(Vector center, ld r) : center(center), r(r) {

    }
};

Vector rotate(Vector v, ld ang) {
    return Vector(cosl(ang) * v.x - sinl(ang) * v.y, sinl(ang) * v.x + cosl(ang) * v.y);
}

vector<Vector> intersection(Circle a, Circle b) {
    ld dist = (a.center - b.center).length();
    if (abs(dist - a.r - b.r) < e) {
        return {a.center + (b.center - a.center).normolized() * a.r};
    }
    if (dist > a.r + b.r + e) {
        return {};
    }
    if (a.r > dist + b.r + e) {
        return {};
    }
    if (b.r > dist + a.r + e) {
        return {};
    }
    ld gg = (a.r * a.r + dist * dist - b.r * b.r) / 2 / a.r / dist;
    ld ang = acosl(gg);
    Vector vec = (b.center - a.center).normolized() * a.r;
    return {a.center + rotate(vec, ang), a.center + rotate(vec, -ang)};
}

bool cmp(pair<ld, ll> &a, pair<ld, ll> &b) {
    return a.first > b.first;
}

ll n;
vector<pair<ld, ll>> a;
vector<Vector> ans;

void solve(Vector s, Vector f, ll ind) {
    if (ind + 2 == n) {
        Vector p;
        if ((s - f).length() < e) {
            p = s + Vector(a[ind].first, 0);
        } else {
            auto gg = intersection(Circle(s, a[ind].first), Circle(f, a[ind + 1].first));
            if (gg.empty()) {
                cout << "Impossible" << endl;
                exit(0);
            }
            p = gg[0];
        }
        ans[a[ind].second] = p - s;
        ans[a[ind + 1].second] = f - p;
        return;
    }
    if ((s - f).length() < e) {
        ans[a[ind].second] = Vector(a[ind].first, 0);
    } else {
        ld r1 = 0;
        for (ll i = ind + 1; i < n; i++) {
            r1 += a[i].first;
        }
        ld r2 = r1 - 2 * a[ind + 1].first;
        r2 = max(r2, ld(0));
        auto i1 = intersection(Circle(s, a[ind].first), Circle(f, r1));
        auto i2 = intersection(Circle(s, a[ind].first), Circle(f, r2));
        if (i1.empty() && i2.empty()) {
            ans[a[ind].second] = Vector(a[ind].first, 0);
        } else if (i1.empty()) {
            ans[a[ind].second] = i2[0] - s;
        } else {
            ans[a[ind].second] = i1[0] - s;
        }
        ans[a[ind].second] = (f - s).normolized() * a[ind].first;
    }
    solve(s + ans[a[ind].second], f, ind + 1);
}

int32_t main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout << fixed << setprecision(10);
    Vector s, f;
    cin >> s >> f;
    cin >> n;
    a.assign(n, {});
    ld mx = 0, sum = 0;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
        mx = max(mx, a[i].first);
        sum += a[i].first;
    }
    if (n == 1) {
        if (abs((s - f).length() - a[0].first) < e) {
            cout << "Possible\n" << f;
        } else {
            cout << "Impossible";
        }
        return 0;
    }
    mx = max(mx, (s - f).length());
    sum += (s - f).length();
    if (2 * mx > sum + e) {
        cout << "Impossible";
        return 0;
    }
    sort(a.begin(), a.end(), cmp);
    ans.assign(n, Vector());
    solve(s, f, 0);
    cout << "Possible\n";
    for (ll i = 0; i < n; i++) {
        s = s + ans[i];
        cout << s << '\n';
    }
}