#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

void solve();

#define int long long
#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define vi vector<ll>
#define vii vector<vi>
#define vip vector<pair<ll, ll>>
#define viip vector<vip>
#define double long double
const int N = 3e5 + 10, MOD = 1e9 + 7;
const int INF = 1e8;
const double EPS = 1e-5, pi = 3.1415926535897932384626;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}

double dist(double ax, double ay, double bx, double by) {
    return hypotl((ax - bx), (ay - by));
}

struct pt {
    double x, y;

    double operator%(pt b) {
        return x * b.y - y * b.x;
    }

    double operator*(pt b) {
        return x * b.x + y * b.y;
    }

    double len() {
        return hypotl(x, y);
    }
};

pair<double, double> pov(double x1, double y1, double a) {
    pt p1 = {x1, y1};
    pt p2 = {1, 0};
    double b = (atan2l(p2 % p1, p2 * p1));
    if (b < 0) {
        b += pi * 2;
    }
    a += b;
    double len = p1.len();
    double y2 = len * sinl(a);
    double x2 = len * cosl(a);
    return {x2, y2};
}

void solve() {
    double ax, ay, bx, by;
    cin >> ax >> ay >> bx >> by;

    int n;
    cin >> n;
    vector<double> a(n);
    double sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }
    double stx = ax, sty = ay;
    double cur = dist(ax, ay, bx, by);
    if (sum < cur) {
        cout << "Impossible" << endl;
        return;
    }
    vector<pair<double, double>> ans;
    for (int i = 0; i < n; i++) {
        sum -= a[i];
        double l = 0, r = pi;
        cur = dist(ax, ay, bx, by);
        double rad = a[i];
        for (int j = 0; j <30; j++) {
            double m = (l + r) / 2;
            double curd = sqrtl(rad * rad + cur * cur - 2 * cur * rad * cosl(m));
            if (curd >= sum) {
                r = m;
            } else {
                l = m;
            }
        }

        double nx = bx - ax, ny = by - ay;
        nx = (nx * rad / (cur));
        ny = (ny * rad / (cur));
        auto [vx, vy] = pov(nx, ny, r);
        pt av = {nx, ny};
        pt bv = {vx, vy};
        double ang = abs(atan2(av % bv, av * bv));
        if (abs(ang - l) > EPS) {
            assert(0);
        }

        vx += ax;
        vy += ay;
        ans.emplace_back(vx, vy);
        ax = vx;
        ay = vy;
    }

    if (abs(ax - bx) > 1e-8 || abs(ay - by) > 1e-8) {
        cout << "Impossible" << endl;
        return;
    }
    double xx = ans[0].first - stx, yy =ans[0].second - sty;
    for (int i = 1; i < ans.size(); i++) {
        xx += ans[i].first - ans[i-1].first;
        yy += ans[i].second - ans[i-1].second;
    }
    assert(abs((bx - stx) - xx) < EPS);
    assert(abs((by - sty) - yy) < EPS);
    cout << "Possible" << endl;
    cout << fixed << setprecision(8);
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first << " " << ans[i].second << endl;
    }
}