#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ld = long double;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

const int N = 250000, inf = 1e9;

struct line {
    ld k = 0, b = 0;

    line() {}

    line(ld K, ld B) : k(K), b(B) {}

    ld get(int x) {
        return k * x + b;
    }
};

vector<line> lines;
vector<int> dots;

int cross(line a, line b) {
    return (b.b - a.b) / (a.k - b.k);
}

void add(line cur) {
    while (!lines.empty() && lines.back().get(dots.back()) > cur.get(dots.back())) {
        lines.pop_back();
        dots.pop_back();
    }
    if (lines.empty()) {
        dots.push_back(0);
        lines.push_back(cur);
    } else {
        int pos = cross(lines.back(), cur);
        if (pos <= inf) {
            dots.push_back(cross(lines.back(), cur));
            lines.push_back(cur);
        }
    }
}

ld get(int x) {
    int pos = lower_bound(dots.begin(), dots.end(), x) - dots.begin() - 1;
    return lines[pos].get(x);
}

void solve() {
    int n, m, c;
    cin >> n >> m >> c;
    ++n;
    vector<int> x(n), t(n);
    for (int i = 1; i < n; ++i) {
        cin >> x[i] >> t[i];
    }
    vector<ld> dp(n);
    add({0, 0});
    for (int i = 1; i < n; ++i) {
        dp[i] = t[i] + (ld) x[i] * x[i] / c + get(x[i]);
        add({(ld) -2 * x[i] / c, dp[i] + (ld) x[i] * x[i] / c});
    }
    cout << (ld) m * m / c + get(m);
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}